"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

Object subclass:#RGBehaviorFactory
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGBehaviorFactory comment:'My subclasses are very simple factories that serve as entry point to create different kind of behaviors. There should be no instances of me.

The behaviors are composition of a RGBehavior instances and a strategy that describes a kind of the behavior. The behavior factory only create sach pairs so for example my subclass RGClass creates a composition of RGBehavior instance with a RGClassStrategy. '
!

!RGBehaviorFactory class methodsFor:'instance creation'!

named: aString

    ^ (RGBehavior named: aString behaviorStrategy: self newStrategy)
        yourself
!

named: aString parent: anRGObject

    ^ (RGBehavior named: aString parent: anRGObject  behaviorStrategy: (self newStrategyFor: anRGObject environment))
        yourself
!

newStrategy

    self subclassResponsibility 
!

newStrategyFor: anRGEnvironment

    ^ self newStrategy
!

parent: anRGObject

    ^ (RGBehavior parent: anRGObject behaviorStrategy: (self newStrategyFor: anRGObject environment))
        yourself
!

unnamed

    ^ RGBehavior unnamedWithBehaviorStrategy: self newStrategy
!

unresolved

    ^ RGBehavior unresolvedWithBehaviorStrategy: self newStrategy
!

unresolvedNamed: aString withParent: anRGDefintion

    ^ RGBehavior unresolvedNamed: aString withParent: anRGDefintion behaviorStrategy: (self newStrategyFor: anRGDefintion environment)
!

unresolvedWithParent: anRGDefintion

    ^ RGBehavior unresolvedWithParent: anRGDefintion behaviorStrategy: (self newStrategyFor: anRGDefintion environment) 
! !

