"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

Object subclass:#RGBehaviorStrategy
	instanceVariableNames:'owner'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGBehaviorStrategy comment:''
!

!RGBehaviorStrategy class methodsFor:'instance creation'!

unresolved

    ^ self basicNew
! !

!RGBehaviorStrategy methodsFor:'accessing'!

classSide

    ^ self owner
!

owner
    ^ owner
!

owner: anObject
    owner := anObject
! !

!RGBehaviorStrategy methodsFor:'accessing - deprecated parallel hierarchy'!

theMetaClass

    ^ self owner
!

theNonMetaClass

    ^ self owner
! !

!RGBehaviorStrategy methodsFor:'accessing - parallel hierarchy'!

instanceSide

    ^ self owner
! !

!RGBehaviorStrategy methodsFor:'class variables'!

classVariableDefinitionString

    self incompatibleBehaviorType
! !

!RGBehaviorStrategy methodsFor:'copying'!

copyForBehaviorDefinitionPostCopy

    super postCopy.
!

copyForBehaviorDefinitionWithOwner: aNewOwner

    ^ self shallowCopy 
        owner: aNewOwner;
        copyForBehaviorDefinitionPostCopy
! !

!RGBehaviorStrategy methodsFor:'default model values'!

defaultMetaClass

    ^ self incompatibleBehaviorType
! !

!RGBehaviorStrategy methodsFor:'initialization'!

initializeUnresolved
! !

!RGBehaviorStrategy methodsFor:'private - backend access'!

addClassVariable: anRGInstanceVariableDefinition 

    self incompatibleBehaviorType
!

addSharedPool: anRGPoolVariable

    self incompatibleBehaviorType
!

allClassVarNames

    self subclassResponsibility 
!

allClassVariables

    self incompatibleBehaviorType
!

baseBehavior

    ^ self owner
!

baseClass

    ^ self owner
!

baseClass: anRGClass

    self incompatibleBehaviorType
!

baseTrait

    self incompatibleBehaviorType
!

baseTrait: anRGClass

    self incompatibleBehaviorType
!

bindingOf: varName

    ^ self owner isRootInEnvironment
        ifFalse: [self owner superclass bindingOf: varName]
        ifTrue: [ nil ]
!

category

    self subclassResponsibility 
!

category: aString

    self incompatibleBehaviorType
!

classTrait

    self incompatibleBehaviorType
!

classTrait: anRGMetaclassTrait

    self incompatibleBehaviorType
!

classVarNames

    ^#()
!

classVariables

    self incompatibleBehaviorType
!

classVariables: aCollectionOfSymbols

    self incompatibleBehaviorType
!

classVariablesDo: aBlock

    self incompatibleBehaviorType
!

classVariablesString

    ^ String new
!

cleanClassVariables

    self incompatibleBehaviorType
!

cleanSharedPools

    self incompatibleBehaviorType
!

comment

    self subclassResponsibility
!

comment: anRGComment

    self incompatibleBehaviorType
!

incompatibleBehaviorType

    RGIncompatibleBehaviorTypeError signal
!

innerBindingOf: aSymbol

    ^ nil
!

instanceVariables: aCollectionOfSymbols

    self incompatibleBehaviorType
!

instanceVariablesString

    ^ String new
!

kindOfSubclass

    self incompatibleBehaviorType
!

makeResolved

    "do nothing"
!

referencedBehaviors

    ^ { self owner superclass. self owner metaclass}, self owner traitComposition referencedBehaviors
!

referencedPackages

    ^ Array new
!

removeClassVariable: anRGInstanceVariableDefinition

    self incompatibleBehaviorType
!

removeSharedPool: anRGPoolVariable

    self incompatibleBehaviorType
!

sharedPoolNames

    ^ OrderedCollection new
!

sharedPools

    ^ OrderedCollection new
!

sharedPools: aCollectionOfSymbols

    self incompatibleBehaviorType
!

sharedPoolsDo: aBlock

    self incompatibleBehaviorType
! !

!RGBehaviorStrategy methodsFor:'testing'!

isClass

    ^ false
!

isClassStrategy

    ^ false
!

isMeta
    "By default a non-meta class is considered"

    ^false
!

isMetaclass
    
    ^ false
!

isMetaclassStrategy

    ^ false
!

isMetaclassTrait
    
    ^ false
!

isMetaclassTraitStrategy

    ^ false
!

isTrait

    ^false
!

isTraitStrategy

    ^ false
! !

!RGBehaviorStrategy methodsFor:'utilities'!

allSlots

    ^ OrderedCollection new
!

announceDefinitionChangeDuring: aBlock

    self owner announceDefinitionChangeDuring: aBlock
!

backend

    ^ self owner backend forBehavior
!

environment

    ^ self owner environment
!

instSize

    ^ 0
!

instVarNames

    ^ OrderedCollection new
!

pvtResolvableProperties

    ^ OrderedCollection new
!

sibling

    ^ self subclassResponsibility 
!

storeName

    self subclassResponsibility 
!

unresolvedValue: aDefaultValue

    ^ self owner unresolvedValue: aDefaultValue
! !

!RGBehaviorStrategy methodsFor:'variables'!

trait

    ^ self incompatibleBehaviorType
! !

!RGBehaviorStrategy methodsFor:'visiting'!

acceptVisitor: aVisitor

    self subclassResponsibility 
! !

