"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

Object subclass:#RGEnvironmentBackend
	instanceVariableNames:'environment providedDefinitions'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Environment'
!

RGEnvironmentBackend comment:''
!

!RGEnvironmentBackend class methodsFor:'as yet unclassified'!

for: anRGEnvironment

    ^ self new 
        environment: anRGEnvironment;
        yourself.
! !

!RGEnvironmentBackend methodsFor:'accesing'!

definitionFor: anObject 

    ^ self definitionFor: anObject ifAbsentRegister: [ anObject ensureRingDefinitionIn: self environment ]
!

definitionFor: anObject ifAbsentRegister: aDefinitionOrBlock

    ^ providedDefinitions at: anObject 
        ifPresent: [:definition | definition ]
        ifAbsentPut: [ aDefinitionOrBlock value ].
!

environment
        
    ^ environment
!

environment: anRGEnironment
        
    environment := anRGEnironment
! !

!RGEnvironmentBackend methodsFor:'as yet unclassified'!

metaclassFor: anRGBehavior

    ^  anRGBehavior pvtMetaclass
!

setMetaclassFor: anRGBehavior to: anRGMetaclass

    ^  anRGBehavior pvtMetaclass: anRGMetaclass
! !

!RGEnvironmentBackend methodsFor:'behavior'!

addLocalMethod: anRGMethod to: anRGBehavior

    ^ anRGBehavior pvtAddLocalMethod: anRGMethod
!

cleanLocalMethodsFor: anRGBehavior

    ^ anRGBehavior pvtCleanLocalMethods
!

layoutFor: anRGBehavior

    ^  anRGBehavior behaviorStrategy pvtLayout
!

localMethodsFor: anRGBehavior do: aBlock

    ^ anRGBehavior pvtLocalMethodsDo: aBlock
!

removeLocalMethod: anRGMethod from: anRGBehavior

    ^ anRGBehavior pvtRemoveLocalMethod: anRGMethod
!

setLayoutFor: anRGBehavior to: anRGLayout

    ^  anRGBehavior behaviorStrategy pvtLayout: anRGLayout
!

setSuperclassFor: anRGBehavior to: anObject

    ^  anRGBehavior pvtSuperclass: anObject
!

setTraitCompositionFor: anRGBehavior to: anRGTraitComposition

    ^  anRGBehavior pvtTraitComposition: anRGTraitComposition
!

superclassFor: anRGBehavior

    ^  anRGBehavior pvtSuperclass
!

traitCompositionFor: anRGBehavior

    ^  anRGBehavior pvtTraitComposition
! !

!RGEnvironmentBackend methodsFor:'class'!

addClassVariable: anRGInstanceVariableDefinition to: anRGBehavior

    ^ anRGBehavior behaviorStrategy pvtAddClassVariable: anRGInstanceVariableDefinition
!

addMethodTag: aSymbol to: anRGBehavior

    ^ anRGBehavior pvtAddMethodTag: aSymbol
!

addSharedPool: anRGPoolVariable to: anRGBehavior

    ^ anRGBehavior behaviorStrategy pvtAddSharedPool: anRGPoolVariable
!

classVariablesFor: anRGBehavior do: aBlock

    ^ anRGBehavior behaviorStrategy pvtClassVariablesDo: aBlock
!

cleanClassTagsFor: anRGBehavior

    anRGBehavior pvtCleanTags.
!

cleanClassVariablesFor: anRGBehavior

    ^ anRGBehavior behaviorStrategy pvtCleanClassVariables
!

cleanSharedPoolsFor: anRGBehavior

    ^ anRGBehavior behaviorStrategy pvtCleanSharedPools
!

cleanTagsForMethodsFor: anRGBehavior

    anRGBehavior pvtCleanTagsForMethods.
!

commentFor: anRGBehavior

    ^  anRGBehavior behaviorStrategy pvtComment
!

packageFor: anRGBehavior

    ^  anRGBehavior behaviorStrategy pvtPackage
!

removeClassVariable: anRGInstanceVariableDefinition from: anRGBehavior

    ^ anRGBehavior behaviorStrategy pvtRemoveClassVariable: anRGInstanceVariableDefinition
!

removeMethodTag: aSymbol from: anRGBehavior

    ^ anRGBehavior pvtRemoveMethodTag: aSymbol
!

removeSharedPool: anRGPoolVariable from: anRGBehavior

    ^ anRGBehavior behaviorStrategy pvtRemoveSharedPool: anRGPoolVariable
!

setCommentFor: anRGBehavior to: anRGComment

    ^  anRGBehavior behaviorStrategy pvtComment: anRGComment
!

setPackageFor: anRGBehavior to: anRGPackage

    ^  anRGBehavior behaviorStrategy pvtPackage: anRGPackage
!

sharedPoolsFor: anRGBehavior do: aBlock

    ^ anRGBehavior behaviorStrategy pvtSharedPoolsDo: aBlock
!

tagClass: anRGBehavior with: aSymbol

    ^ anRGBehavior pvtTagWith: aSymbol
!

tagsForClass: anRGBehavior do: aBlock

    ^  anRGBehavior pvtTagsDo: aBlock
!

tagsForMethodsFor: anRGBehavior do: aBlock

    ^  anRGBehavior pvtTagsForMethodsDo: aBlock
!

untagClass: anRGBehavior from: aSymbol

    ^ anRGBehavior pvtUntagFrom: aSymbol
! !

!RGEnvironmentBackend methodsFor:'class comment'!

classCommentAuthorFor: anRGComment

    ^  anRGComment pvtAuthor
!

classCommentContentFor: anRGComment

    ^ anRGComment pvtContent
!

classCommentTimeFor: anRGComment

    ^  anRGComment pvtTime
!

setClassCommentAuthorFor: anRGComment to: aString

    ^  anRGComment pvtAuthor: aString
!

setClassCommentContentFor: anRGComment to: anObject

    anRGComment pvtContent: anObject.
!

setClassCommentTimeFor: anRGComment to: aDateAndTime

    ^  anRGComment pvtTime: aDateAndTime
! !

!RGEnvironmentBackend methodsFor:'environment'!

addBehavior: anRGBehavior to: anRGEnvironment

    ^ anRGEnvironment pvtAddBehavior: anRGBehavior
!

addGlobalVariable: anRGGlobalVariable to: anRGEnvironment

    ^ anRGEnvironment pvtAddGlobalVariable: anRGGlobalVariable
!

addPackage: anRGPackage to: anRGEnvironment

    ^ anRGEnvironment pvtAddPackage: anRGPackage
!

behaviorsFor: anRGEnvironment do: aBlock

    ^  anRGEnvironment pvtBehaviorsDo: aBlock
!

cleanBehaviorsFor: anRGEnvironment

    anRGEnvironment pvtCleanBehaviors.
!

cleanGlobalVariablesFor: anRGEnvironment

    ^ anRGEnvironment pvtCleanGlobalVariables
!

cleanPackagesFor: anRGEnvironment

    anRGEnvironment pvtCleanPackages
!

globalVariablesFor: anRGEnvironment do: aBlock

    ^ anRGEnvironment pvtGlobalVariablesDo: aBlock
!

packagesFor: anRGEnvironment do: aBlock

    ^  anRGEnvironment pvtPackagesDo: aBlock
!

removeBehavior: anRGBehavior from: anRGEnvironment

    anRGEnvironment pvtRemoveBehavior: anRGBehavior.
    
!

removeGlobalVariable: anRGGlobalVariable from: anRGEnvironment

    ^ anRGEnvironment pvtRemoveGlobalVariable: anRGGlobalVariable
!

removePackage: anRGPackage from: anRGEnvironment

    ^ anRGEnvironment pvtRemovePackage: anRGPackage
! !

!RGEnvironmentBackend methodsFor:'general'!

nameFor: anRGObject

    ^ anRGObject pvtName
!

setNameFor: anRGObject to: aString

    ^ anRGObject pvtName: aString
! !

!RGEnvironmentBackend methodsFor:'initialization'!

initialize

    super initialize.
    
    providedDefinitions := IdentityDictionary new.
! !

!RGEnvironmentBackend methodsFor:'metaclass'!

baseClassFor: anRGBehavior

    ^  anRGBehavior behaviorStrategy pvtBaseClass
!

setBaseClassFor: anRGBehavior to: anRGClass

    ^  anRGBehavior behaviorStrategy pvtBaseClass: anRGClass
! !

!RGEnvironmentBackend methodsFor:'metaclass trait'!

metaclassTraitBaseTraitFor: anRGMetaclassTrait

    ^  anRGMetaclassTrait behaviorStrategy pvtBaseTrait
!

setMetaclassTraitBaseTraitFor: anRGMetaclassTrait to: anRGTrait

    ^  anRGMetaclassTrait pvtBaseTrait: anRGTrait
! !

!RGEnvironmentBackend methodsFor:'method'!

astFor: anRGMethod

    ^  anRGMethod astFromSource
!

authorFor: anRGMethod

    ^  anRGMethod pvtAuthor
!

cleanMethodTagsFor: anRGMethod

    anRGMethod pvtCleanTags.
!

hasSourceCodeFor: anRGMethod 

    ^ anRGMethod pvtSourceCode notNil
!

methodPackageFor: anRGMethod

    ^  anRGMethod pvtPackage
!

setAuthorFor: anRGMethod to: aDateAndTime

    ^  anRGMethod pvtAuthor: aDateAndTime
!

setMethodPackageFor: anRGMethod to: anRGPackage

    ^  anRGMethod pvtPackage: anRGPackage
!

setSourceCodeFor: anRGMethod to: anObject

    anRGMethod pvtSourceCode: anObject
!

setTimeFor: anRGMethod to: aDateAndTime

    ^  anRGMethod pvtTime: aDateAndTime
!

sourceCodeFor: anRGMethod 

    ^ anRGMethod pvtSafeSourceCode
!

tagMethod: anRGMethod with: aSymbol

    ^ anRGMethod pvtTagWith: aSymbol
!

tagsForMethod: anRGMethod do: aBlock

    ^  anRGMethod pvtTagsDo: aBlock
!

timeFor: anRGMethod

    ^  anRGMethod pvtTime
!

untagMethod: anRGMethod from: aSymbol

    ^ anRGMethod pvtUntagFrom: aSymbol
    
! !

!RGEnvironmentBackend methodsFor:'package'!

addClassTag: aSymbol to: anRGPackage

    ^ anRGPackage pvtAddClassTag: aSymbol
!

addDefinedBehavior: anRGBehavior to: anRGPackage

    ^ anRGPackage pvtAddDefinedBehavior: anRGBehavior
!

addExtensionMethod: anRGMethod to: anRGPackage

    ^ anRGPackage pvtAddExtensionMethod: anRGMethod
!

cleanDefinedBehaviorsFor: anRGPackage

    anRGPackage pvtCleanDefinedBehaviors.
!

cleanExtensionMethodsFor: anRGPackage

    anRGPackage pvtCleanExtensionMethods
!

cleanTagsForClassesFor: anRGPackage

    anRGPackage pvtCleanTagsForClasses.
!

definedBehaviorsFor: anRGPackage do: aBlock

    ^  anRGPackage pvtDefinedBehaviorsDo: aBlock
!

extensionMethodsFor: anRGPackage do: aBlock

    ^ anRGPackage pvtExtensionMethodsDo: aBlock
!

removeClassTag: aSymbol from: anRGPackage

    ^ anRGPackage pvtRemoveClassTag: aSymbol
!

removeDefinedBehavior: anRGBehavior from: anRGPackage

    ^ anRGPackage pvtRemoveDefinedBehavior: anRGBehavior
!

removeExtensionMethod: anRGMethod from: anRGPackage

    ^ anRGPackage pvtRemoveExtensionMethod: anRGMethod
!

tagsForClassesFor: anRGPackage do: aBlock

    ^  anRGPackage pvtTagsForClassesDo: aBlock
! !

!RGEnvironmentBackend methodsFor:'pointer layout'!

addSlot: anRGSlot to: anRGLayout

    ^ anRGLayout pvtAddSlot: anRGSlot
!

cleanSlotsFor: anRGLayout

    ^ anRGLayout pvtCleanSlots
!

removeSlot: anRGSlot from: anRGLayout

    ^ anRGLayout pvtRemoveSlot: anRGSlot
!

slotsFor: anRGLayout do: aBlock

    ^ anRGLayout pvtSlotsDo: aBlock
! !

!RGEnvironmentBackend methodsFor:'resolving'!

hasFullyResolved: anRGObject

    ^ anRGObject pvtFullyResolved
!

hasFullyUnresolved: anRGObject		
        
    ^ anRGObject pvtFullyUnresolved
!

resolvedPropertiesFor: anRGObject

    ^ anRGObject pvtResolvedProperties
!

unresolvedPropertiesFor: anRGObject

    ^ anRGObject pvtUnresolvedProperties
! !

!RGEnvironmentBackend methodsFor:'slot'!

expressionFor: anRGUnknownSlot

    ^  anRGUnknownSlot pvtExpression
!

setExpressionFor: anRGUnknownSlot to: aString

    ^  anRGUnknownSlot pvtExpression: aString
! !

!RGEnvironmentBackend methodsFor:'subbackends'!

forBehavior

    ^ self 
!

forEnvironment

    ^ self 
!

forMethod

    ^ self 
!

forPackage

    ^ self 
! !

!RGEnvironmentBackend methodsFor:'trait'!

classTraitFor: anRGTrait

    ^  anRGTrait behaviorStrategy pvtClassTrait
!

setClassTraitFor: anRGTrait to: anRGMetatraitDefinition

    ^  anRGTrait behaviorStrategy pvtClassTrait: anRGMetatraitDefinition
!

setTraitCommentFor: anRGBehavior to: anRGComment

    ^  anRGBehavior behaviorStrategy pvtComment: anRGComment
!

setTraitPackageFor: anRGBehavior to: anRGPackage

    ^  anRGBehavior pvtPackage: anRGPackage
!

traitCommentFor: anRGBehavior

    ^  anRGBehavior behaviorStrategy pvtComment
!

traitPackageFor: anRGBehavior

    ^  anRGBehavior behaviorStrategy pvtPackage
! !

!RGEnvironmentBackend methodsFor:'trait alias'!

addAlias: aSymbol to: anRGTraitAlias

    ^ anRGTraitAlias pvtAddAlias: aSymbol
!

aliasesFor: anRGTraitAlias do: aBlock

    ^ anRGTraitAlias pvtAliasesDo: aBlock
!

cleanAliasesFor: anRGTraitAlias

    ^ anRGTraitAlias pvtCleanAliases
!

removeAlias: aSymbol from: anRGTraitAlias

    ^ anRGTraitAlias pvtRemoveAlias: aSymbol
! !

!RGEnvironmentBackend methodsFor:'trait composition'!

addTransformation: anRGTraitTransformation to: anRGTraitComposition

    ^ anRGTraitComposition pvtAddTransformation: anRGTraitTransformation
!

cleanTransformationsFor: anRGTraitComposition

    ^ anRGTraitComposition pvtCleanTransformations
!

removeTransformation: anRGTraitTransformation from: anRGTraitComposition

    ^ anRGTraitComposition pvtRemoveTransformation: anRGTraitTransformation
!

transformationsFor: anRGTraitComposition do: aBlock

    ^ anRGTraitComposition pvtTransformationsDo: aBlock
! !

!RGEnvironmentBackend methodsFor:'trait exclusion'!

addExclusion: aSymbol to: anRGTraitExclusion

    ^ anRGTraitExclusion pvtAddExclusion: aSymbol
!

cleanExclusionsFor: anRGTraitExclusion

    ^ anRGTraitExclusion pvtCleanExclusions
!

exclusionsFor: anRGTraitExclusion do: aBlock

    ^ anRGTraitExclusion pvtExclusionsDo: aBlock
!

removeExclusion: aSymbol from: anRGTraitExclusion

    ^ anRGTraitExclusion pvtRemoveExclusion: aSymbol
! !

!RGEnvironmentBackend methodsFor:'trait transormation'!

setSubjectFor: anRGTraitComposition to: anRGTrait

    ^  anRGTraitComposition pvtSubject: anRGTrait
!

subjectFor: anRGTraitComposition

    ^  anRGTraitComposition pvtSubject
! !

!RGEnvironmentBackend methodsFor:'unresolved objects'!

createNewUnresolvedClass

    | classStub metaclassStub packageStub |
    
    classStub := RGClass unresolvedWithParent: self environment.
    packageStub := RGPackage unresolvedWithParent: self environment.
    classStub behaviorStrategy pvtPackage: packageStub.
    packageStub pvtAddDefinedBehavior: classStub.
    metaclassStub := self createNewUnresolvedMetaclassFor: classStub.

    classStub pvtSuperclass: classStub.
    classStub pvtMetaclass: metaclassStub.
    classStub pvtPackage: packageStub.
    packageStub pvtAddDefinedBehavior: classStub.
    self environment pvtAddBehavior: classStub.
    self environment pvtAddPackage: packageStub.

    ^ classStub
    

!

createNewUnresolvedMetaclassFor: anRGBehavior

    | metaclassStub superclassMetaclass |
    
    metaclassStub := RGMetaclass unresolvedWithParent: self environment.

    superclassMetaclass := anRGBehavior pvtSuperclass pvtMetaclass.
    superclassMetaclass 
        ifNotNil: [ 
            metaclassStub pvtSuperclass: superclassMetaclass.
            metaclassStub pvtMetaclass: superclassMetaclass ]
        ifNil: [ 
            metaclassStub pvtSuperclass: metaclassStub.
            metaclassStub pvtMetaclass: metaclassStub ].
    self environment pvtAddBehavior: metaclassStub.

    ^ metaclassStub	
!

createUnresolvedClassGroupFor: anRGBehavior 

    | classStub metaclassStub superclassStub superclassMetaclassStub packageStub1 packageStub2 |

    classStub := anRGBehavior isMeta
        ifFalse: [ anRGBehavior ]
        ifTrue: [ RGClass unresolvedWithParent: self environment ].
    classStub propertyNamed: #creator put: anRGBehavior.
    classStub propertyNamed: #role put: #class.
        
    metaclassStub := anRGBehavior isMeta
        ifFalse: [ RGMetaclass unresolvedWithParent: self environment ]
        ifTrue: [ anRGBehavior ].
    metaclassStub propertyNamed: #creator put: anRGBehavior.
    metaclassStub propertyNamed: #role put: #metaclass.

    superclassStub := RGClass unresolvedWithParent: self environment.
    superclassStub propertyNamed: #creator put: anRGBehavior.
    superclassStub propertyNamed: #role put: #superclass.

    superclassMetaclassStub := RGMetaclass unresolvedWithParent: self environment.
    superclassMetaclassStub propertyNamed: #creator put: anRGBehavior.
    superclassMetaclassStub propertyNamed: #role put: #superclassMetaclass.
    
    packageStub1 := RGPackage unresolvedWithParent: self environment.
    classStub behaviorStrategy pvtPackage: packageStub1.
    self environment pvtAddPackage: packageStub1.
    packageStub1 pvtAddDefinedBehavior: classStub.
    packageStub1 propertyNamed: #creator put: anRGBehavior.
    packageStub1 propertyNamed: #role put: #package.
    
    packageStub2 := RGPackage unresolvedWithParent: self environment.
    superclassStub behaviorStrategy pvtPackage: packageStub2.
    self environment pvtAddPackage: packageStub2.
    packageStub2 pvtAddDefinedBehavior: superclassStub.
    packageStub2 propertyNamed: #creator put: anRGBehavior.
    packageStub2 propertyNamed: #role put: #superclassPackage.

    classStub pvtSuperclass: superclassStub.
    classStub pvtMetaclass: metaclassStub.
    
    superclassStub pvtSuperclass: superclassStub.
    superclassStub pvtMetaclass: superclassMetaclassStub.
    
    metaclassStub pvtSuperclass: superclassMetaclassStub.
    metaclassStub pvtMetaclass: superclassMetaclassStub.
    metaclassStub behaviorStrategy pvtBaseClass: classStub.
    
    superclassMetaclassStub pvtSuperclass: superclassMetaclassStub.
    superclassMetaclassStub pvtMetaclass: superclassMetaclassStub.
    superclassMetaclassStub behaviorStrategy pvtBaseClass: superclassStub.
    
    self environment pvtAddBehavior: classStub.
    self environment pvtAddBehavior: metaclassStub. 	
    self environment pvtAddBehavior: superclassStub.
    self environment pvtAddBehavior: superclassMetaclassStub.
    

    ^ 	anRGBehavior isMeta
        ifFalse: [ metaclassStub ]
        ifTrue: [ classStub ].
!

createUnresolvedTraitGroupFor: anRGBehavior 

    | traitStub classTraitStub traitMetaclassStub classTraitMetaclassStub packageStub1  |

    traitStub := anRGBehavior isMeta
        ifFalse: [ anRGBehavior ]
        ifTrue: [ RGTrait unresolvedWithParent: self environment ].
    traitStub propertyNamed: #creator put: anRGBehavior.
    traitStub propertyNamed: #role put: #trait.
        
    classTraitStub := anRGBehavior isMeta
        ifFalse: [ RGMetaclassTrait unresolvedWithParent: self environment ]
        ifTrue: [ anRGBehavior ].
    classTraitStub propertyNamed: #creator put: anRGBehavior.
    classTraitStub propertyNamed: #role put: #classTrait.

    "Trait"
    traitMetaclassStub := RGClass unresolvedWithParent: self environment.
    self createUnresolvedClassGroupFor: traitMetaclassStub.
    traitMetaclassStub propertyNamed: #creator put: anRGBehavior.
    traitMetaclassStub propertyNamed: #role put: #traitMetaclass.
    
    "ClassTrait"
    classTraitMetaclassStub := RGClass unresolvedWithParent: self environment.
    self createUnresolvedClassGroupFor: classTraitMetaclassStub.
    classTraitMetaclassStub propertyNamed: #creator put: anRGBehavior.
    classTraitMetaclassStub propertyNamed: #role put: #classTraitMetaclass.

    packageStub1 := RGPackage unresolvedWithParent: self environment.
    packageStub1 propertyNamed: #creator put: anRGBehavior.
    packageStub1 propertyNamed: #role put: #traitMetaclassPackage.

    traitStub behaviorStrategy pvtPackage: packageStub1.
    packageStub1 pvtAddDefinedBehavior: traitStub.
    traitStub pvtSuperclass: traitStub.
    traitStub pvtMetaclass: traitMetaclassStub.
    traitStub behaviorStrategy pvtClassTrait: classTraitStub.

    classTraitStub pvtSuperclass: classTraitStub.
    classTraitStub pvtMetaclass: classTraitMetaclassStub.
    classTraitStub behaviorStrategy pvtBaseTrait: traitStub.
    
    self environment pvtAddBehavior: traitStub.		
    self environment pvtAddBehavior: classTraitStub.	
    self environment pvtAddBehavior: traitMetaclassStub.
    self environment pvtAddBehavior: classTraitMetaclassStub.
    self environment pvtAddPackage: packageStub1.

    ^ 	anRGBehavior isMeta
        ifFalse: [ traitStub ]
        ifTrue: [ classTraitStub ].
! !

