"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGSlot subclass:#RGUnknownSlot
	instanceVariableNames:'expression'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGUnknownSlot comment:''
!

!RGUnknownSlot methodsFor:'accessing - backend'!

expression

    ^ self backend forBehavior expressionFor: self
!

expression: aString

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior setExpressionFor: self to: aString ].

! !

!RGUnknownSlot methodsFor:'default model values'!

defaultExpression

    'InstanceVariableSlot named: #slotOfUnknownType'
! !

!RGUnknownSlot methodsFor:'initialization'!

initialize

    super initialize.
    
    expression := self unresolvedValue: self defaultExpression.
!

initializeUnresolved

    super initializeUnresolved.
    
    expression := self unresolvedValue: self defaultExpression.
! !

!RGUnknownSlot methodsFor:'private - backend interface'!

definitionString

    ^ String streamContents: [ :aStream |
        aStream nextPutAll: '#'; nextPutAll: self name; nextPutAll: ' => '; nextPutAll: self expression ]
!

pvtExpression

    ^ expression value
!

pvtExpression: aString

    ^ expression := aString
!

pvtResolvableProperties

    ^ super pvtResolvableProperties, { 
        #expression -> expression. 
    }
    
    
! !

!RGUnknownSlot methodsFor:'resolving'!

makeResolved

    super makeResolved.
    
    expression := self expression markAsRingResolved.
! !

