"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGElement subclass:#RGVariable
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGVariable comment:'A variable definition'
!

!RGVariable methodsFor:'accessing'!

definitionString
    "non special globals are defined by the symbol"
    ^self needsFullDefinition
        ifTrue: [ String streamContents: [ :aStream |
            aStream nextPutAll: '#'; nextPutAll: self name]]
        ifFalse: [self name printString]
!

name: aString

    self parent announceDefinitionChangeDuring: [ 
        super name: aString ].
! !

!RGVariable methodsFor:'testing'!

isArgumentVariable
    ^false
!

isClassInstanceVariable

    ^false
!

isClassVariable

    ^false
!

isInstanceVariable
    "check if the var is an instance variable (a Slot)"
    ^false
!

isLocalVariable
    ^false
!

isPoolVariable

    ^false
!

isReservedVariable
    "Ring2 does not model self, super, thisContext"
    ^false
!

isSpecial
    ^ self
        deprecated: 'Please use #needsFullDefinition instead '
        on: '03/11/2020'
        in: #Pharo8
        transformWith: '`@receiver isSpecial' 
                        -> '`@receiver needsFullDefinition'.
!

isTempVariable
    ^false
!

isUninitialized
    ^false
!

isVariable
    ^true
!

isWorkspaceVariable
    ^ false
!

isWritable
    "Ring2 variables are all writable, e.g. it does not model Arguments"
    ^true
!

needsFullDefinition
    "all but InstanceVariableSlot and ClassVariable need to print the full definition"
    ^true
! !

!RGVariable methodsFor:'visiting'!

acceptVisitor: aProgramNodeVisitor node: aNode
    ^ aProgramNodeVisitor visitVariableNode: aNode
! !

