"{ Package: 'stx:goodies/ring/core/tests' }"

"{ NameSpace: Smalltalk }"

RGTest subclass:#RGSlotTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Tests-Core'
!

RGSlotTest comment:''
!

!RGSlotTest methodsFor:'tests'!

testNewSlot

    | slot | 
    slot  := RGFixedLayout unnamed.
    self assert: (slot isRingResolved).
    self assert: (slot hasUnresolved: #name).
    self assert: (slot isLayout).
    
!

testResolvingConsistency

    | anObject |
    anObject := RGInstanceVariableSlot unnamed.
    self checkClassesConsistency: anObject and: anObject makeResolved
!

testResolvingConsistencyUnknown

    | anObject |
    anObject := RGUnknownSlot unnamed.
    self checkClassesConsistency: anObject and: anObject makeResolved
!

testSlotsImplicitEnvironment

    | layout |
    
    layout := RGInstanceVariableSlot unnamed.
    self assert: (layout hasUnresolved: #name).
    self assert: (layout parent isLayout).
    self checkImplicitSingleClassEnvironmentOf: layout parent parent.
    
    
    
    
!

testUnknownSlot

    | slot expression | 
    slot  := RGUnknownSlot unnamed.
    self assert: (slot isRingResolved).
    self assert: (slot hasUnresolvedAll: #(name expression)).
    self assert: (slot isSlot).
    expression := 'ToManyRelationSlot inverse: #director inClass: #SlotExampleMovie'.
    slot expression: expression.
    self assert: slot expression equals: expression.
    
! !

